/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt5.dat, Mon Dec 19 17:09:56 2022
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001920 (6432)
 *     Revision         0x01
 *     Checksum         0x0F
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "SataAhci"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20141107 (538185991)
 */
DefinitionBlock ("", "SSDT", 1, "LENOVO", "SataAhci", 0x00001000)
{
    /*
     * iASL Warning: There were 3 external control methods found during
     * disassembly, but only 0 were resolved (3 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0.GPCB, UnknownObj)
    External (_SB_.PCI0.LPC_.CSON, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.BDEV, UnknownObj)
    External (_SB_.PCI0.LPC_.EC__.BEJ0, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.LPC_.EC__.BGID, IntObj)
    External (_SB_.PCI0.LPC_.EC__.BSTA, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.LPC_.EPWG, UnknownObj)
    External (_SB_.PCI0.SAT1, DeviceObj)
    External (_SB_.PCI0.SAT1.SDSM, IntObj)
    External (CDAH, IntObj)
    External (CDFL, IntObj)
    External (DPP0, UnknownObj)
    External (DPP1, UnknownObj)
    External (DPP2, UnknownObj)
    External (DPP3, UnknownObj)
    External (DPP4, UnknownObj)
    External (IDET, UnknownObj)
    External (ND11, IntObj)
    External (ND12, IntObj)
    External (ND13, IntObj)
    External (ND21, IntObj)
    External (ND22, IntObj)
    External (ND23, IntObj)
    External (NEA1, IntObj)
    External (NEA2, IntObj)
    External (NEA3, IntObj)
    External (NEB1, IntObj)
    External (NEB2, IntObj)
    External (NEB3, IntObj)
    External (NEC1, IntObj)
    External (NEC2, IntObj)
    External (NEC3, IntObj)
    External (NIT1, IntObj)
    External (NIT2, IntObj)
    External (NIT3, IntObj)
    External (NL11, IntObj)
    External (NL12, IntObj)
    External (NL13, IntObj)
    External (NLD1, IntObj)
    External (NLD2, IntObj)
    External (NLD3, IntObj)
    External (NLR1, IntObj)
    External (NLR2, IntObj)
    External (NLR3, IntObj)
    External (NMB1, IntObj)
    External (NMB2, IntObj)
    External (NMB3, IntObj)
    External (NMV1, IntObj)
    External (NMV2, IntObj)
    External (NMV3, IntObj)
    External (NPB1, IntObj)
    External (NPB2, IntObj)
    External (NPB3, IntObj)
    External (NPC1, IntObj)
    External (NPC2, IntObj)
    External (NPC3, IntObj)
    External (NPM1, IntObj)
    External (NPM2, IntObj)
    External (NPM3, IntObj)
    External (NPV1, IntObj)
    External (NPV2, IntObj)
    External (NPV3, IntObj)
    External (NRA1, IntObj)
    External (NRA2, IntObj)
    External (NRA3, IntObj)
    External (ODDF, UnknownObj)
    External (PCIC, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (PCID, IntObj)

    Scope (\_SB.PCI0.SAT1)
    {
        Device (PRT0)
        {
            Name (DIP0, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5               // ......
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3               // ......
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0xFFFF)  // _ADR: Address
            Scope (\_SB.PCI0.SAT1)
            {
                Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
                {
                    If (PCIC (Arg0))
                    {
                        Return (PCID) /* External reference */
                        Arg0
                        Arg1
                        Arg2
                        Arg3
                    }

                    If (CondRefOf (\_SB.PCI0.SAT1.SDSM))
                    {
                        Return (\_SB.PCI0.SAT1.SDSM) /* External reference */
                        Arg0
                        Arg1
                        Arg2
                        Arg3
                    }

                    Return (0x00)
                }

                Method (RDCA, 5, Serialized)
                {
                    OperationRegion (RPAL, SystemMemory, (\_SB.PCI0.GPCB + (0x000B8100 + Arg1)), 0x04)
                    Field (RPAL, DWordAcc, Lock, Preserve)
                    {
                        RPCD,   32
                    }

                    OperationRegion (EPAC, SystemMemory, (\_SB.PCI0.GPCB + 0x000B8308), 0x08)
                    Field (EPAC, DWordAcc, Lock, Preserve)
                    {
                        CAIR,   32, 
                        CADR,   32
                    }

                    OperationRegion (NCRG, SystemMemory, (\_SB.PCI0.GPCB + 0x000B8FC0), 0x04)
                    Field (NCRG, DWordAcc, Lock, Preserve)
                    {
                        CRGC,   32
                    }

                    If ((Arg0 > 0x02))
                    {
                        Return (0x00)
                    }
                    Else
                    {
                        CRGC = Arg0
                    }

                    Switch (ToInteger (Arg4))
                    {
                        Case (0x00)
                        {
                            Return (RPCD) /* \_SB_.PCI0.SAT1.RDCA.RPCD */
                        }
                        Case (0x02)
                        {
                            CAIR = Arg1
                            Return (CADR) /* \_SB_.PCI0.SAT1.RDCA.CADR */
                        }
                        Case (0x01)
                        {
                            Local0 = (Arg2 & RPCD) /* \_SB_.PCI0.SAT1.RDCA.RPCD */
                            Local0 |= Arg3
                            RPCD = Local0
                        }
                        Case (0x03)
                        {
                            CAIR = Arg1
                            Local0 = (Arg2 & CADR) /* \_SB_.PCI0.SAT1.RDCA.CADR */
                            Local0 |= Arg3
                            CADR = Local0
                        }
                        Default
                        {
                            Return (0x00)
                        }

                    }
                }

                Method (RPD0, 1, Serialized)
                {
                    RDCA (Arg0, 0xA4, 0xFFFFFFFC, 0x00, 0x01)
                }

                Method (RPD3, 1, Serialized)
                {
                    RDCA (Arg0, 0xA4, 0xFFFFFFFC, 0x03, 0x01)
                }

                Device (NVM1)
                {
                    Name (_ADR, 0x00C1FFFF)  // _ADR: Address
                    Name (PRBI, 0x00)
                    Name (PRBD, 0x00)
                    Name (PCMD, 0x00)
                    Name (NCRN, 0x00)
                    Name (NITV, 0x00)
                    Name (NPMV, 0x00)
                    Name (NPCV, 0x00)
                    Name (NL1V, 0x00)
                    Name (ND2V, 0x00)
                    Name (ND1V, 0x00)
                    Name (NLRV, 0x00)
                    Name (NLDV, 0x00)
                    Name (NEAV, 0x00)
                    Name (NEBV, 0x00)
                    Name (NECV, 0x00)
                    Name (NRAV, 0x00)
                    Name (NMBV, 0x00)
                    Name (NMVV, 0x00)
                    Name (NPBV, 0x00)
                    Name (NPVV, 0x00)
                    Method (EPD0, 0, Serialized)
                    {
                        RDCA (NCRN, (NPMV + 0x04), 0xFFFFFFFC, 0x00, 0x03)
                    }

                    Method (EPD3, 0, Serialized)
                    {
                        RDCA (NCRN, (NPMV + 0x04), 0xFFFFFFFC, 0x03, 0x03)
                    }

                    Method (CNRS, 0, Serialized)
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        RDCA (NCRN, 0x10, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x14, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x18, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x1C, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x20, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x24, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x04, 0xFFFFFFF8, PCMD, 0x03)
                        RDCA (NCRN, PRBI, 0x00, PRBD, 0x03)
                        If ((NL1V != 0x00))
                        {
                            RDCA (NCRN, (NL1V + 0x0C), 0xFFFFFF00, ND2V, 0x03)
                            RDCA (NCRN, (NL1V + 0x08), 0x0F, (ND1V & 0xFFFFFFF0), 0x03)
                            RDCA (NCRN, (NL1V + 0x08), 0xFFFFFFFF, ND1V, 0x03)
                        }

                        If ((NLRV != 0x00))
                        {
                            RDCA (NCRN, (NLRV + 0x04), 0xFFFFFFFF, NLDV, 0x03)
                        }

                        RDCA (NCRN, (NPCV + 0x10), 0xFFFFFEBF, (NEAV & 0xFFFC), 0x03)
                        RDCA (NCRN, (NPCV + 0x28), 0xFFFFFBFF, NECV, 0x03)
                        RDCA (NCRN, (NPCV + 0x08), 0xFFFFFF1F, NEBV, 0x03)
                        RDCA (NCRN, 0x68, 0xFFFFFBFF, NRAV, 0x01)
                        If (((NEAV & 0x40) == 0x40))
                        {
                            RDCA (NCRN, 0x50, 0xFFFFFFDF, 0x20, 0x01)
                            While (((RDCA (NCRN, 0x52, 0x00, 0x00, 0x00) & 0x2000) == 0x00))
                            {
                                Stall (0x0A)
                            }
                        }

                        RDCA (NCRN, (NPCV + 0x10), 0xFFFFFFFC, (NEAV & 0x03), 0x03)
                        If ((NMVV != 0x00))
                        {
                            RDCA (NCRN, NMBV, 0x00, NMVV, 0x03)
                        }

                        If ((NPVV != 0x00))
                        {
                            RDCA (NCRN, NPBV, 0x00, NPVV, 0x03)
                        }

                        Return (0x00)
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        PCMD = RDCA (NCRN, 0x04, 0x00, 0x00, 0x02)
                        If ((NITV == 0x01))
                        {
                            PRBI = 0x24
                            PRBD = RDCA (NCRN, 0x24, 0x00, 0x00, 0x02)
                        }
                        ElseIf ((NITV == 0x02))
                        {
                            PRBI = 0x10
                            PRBD = RDCA (NCRN, 0x10, 0x00, 0x00, 0x02)
                        }

                        EPD3 ()
                        RPD3 (NCRN)
                        Return (0x00)
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        RPD0 (NCRN)
                        EPD0 ()
                        Local0 = RDCA (NCRN, (NPMV + 0x04), 0x00, 0x00, 0x02)
                        If (((Local0 & 0x08) == 0x00))
                        {
                            CNRS ()
                        }

                        Return (0x00)
                    }

                    Method (_INI, 0, NotSerialized)  // _INI: Initialize
                    {
                        NITV = NIT1 /* External reference */
                        NPMV = NPM1 /* External reference */
                        NPCV = NPC1 /* External reference */
                        NL1V = NL11 /* External reference */
                        ND2V = ND21 /* External reference */
                        ND1V = ND11 /* External reference */
                        NLRV = NLR1 /* External reference */
                        NLDV = NLD1 /* External reference */
                        NEAV = NEA1 /* External reference */
                        NEBV = NEB1 /* External reference */
                        NECV = NEC1 /* External reference */
                        NRAV = NRA1 /* External reference */
                        NMBV = NMB1 /* External reference */
                        NMVV = NMV1 /* External reference */
                        NPBV = NPB1 /* External reference */
                        NPVV = NPV1 /* External reference */
                        NCRN = 0x00
                    }
                }

                Device (NVM2)
                {
                    Name (_ADR, 0x00C2FFFF)  // _ADR: Address
                    Name (PRBI, 0x00)
                    Name (PRBD, 0x00)
                    Name (PCMD, 0x00)
                    Name (NCRN, 0x00)
                    Name (NITV, 0x00)
                    Name (NPMV, 0x00)
                    Name (NPCV, 0x00)
                    Name (NL1V, 0x00)
                    Name (ND2V, 0x00)
                    Name (ND1V, 0x00)
                    Name (NLRV, 0x00)
                    Name (NLDV, 0x00)
                    Name (NEAV, 0x00)
                    Name (NEBV, 0x00)
                    Name (NECV, 0x00)
                    Name (NRAV, 0x00)
                    Name (NMBV, 0x00)
                    Name (NMVV, 0x00)
                    Name (NPBV, 0x00)
                    Name (NPVV, 0x00)
                    Method (EPD0, 0, Serialized)
                    {
                        RDCA (NCRN, (NPMV + 0x04), 0xFFFFFFFC, 0x00, 0x03)
                    }

                    Method (EPD3, 0, Serialized)
                    {
                        RDCA (NCRN, (NPMV + 0x04), 0xFFFFFFFC, 0x03, 0x03)
                    }

                    Method (CNRS, 0, Serialized)
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        RDCA (NCRN, 0x10, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x14, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x18, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x1C, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x20, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x24, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x04, 0xFFFFFFF8, PCMD, 0x03)
                        RDCA (NCRN, PRBI, 0x00, PRBD, 0x03)
                        If ((NL1V != 0x00))
                        {
                            RDCA (NCRN, (NL1V + 0x0C), 0xFFFFFF00, ND2V, 0x03)
                            RDCA (NCRN, (NL1V + 0x08), 0x0F, (ND1V & 0xFFFFFFF0), 0x03)
                            RDCA (NCRN, (NL1V + 0x08), 0xFFFFFFFF, ND1V, 0x03)
                        }

                        If ((NLRV != 0x00))
                        {
                            RDCA (NCRN, (NLRV + 0x04), 0xFFFFFFFF, NLDV, 0x03)
                        }

                        RDCA (NCRN, (NPCV + 0x10), 0xFFFFFEBF, (NEAV & 0xFFFC), 0x03)
                        RDCA (NCRN, (NPCV + 0x28), 0xFFFFFBFF, NECV, 0x03)
                        RDCA (NCRN, (NPCV + 0x08), 0xFFFFFF1F, NEBV, 0x03)
                        RDCA (NCRN, 0x68, 0xFFFFFBFF, NRAV, 0x01)
                        If (((NEAV & 0x40) == 0x40))
                        {
                            RDCA (NCRN, 0x50, 0xFFFFFFDF, 0x20, 0x01)
                            While (((RDCA (NCRN, 0x52, 0x00, 0x00, 0x00) & 0x2000) == 0x00))
                            {
                                Stall (0x0A)
                            }
                        }

                        RDCA (NCRN, (NPCV + 0x10), 0xFFFFFFFC, (NEAV & 0x03), 0x03)
                        If ((NMVV != 0x00))
                        {
                            RDCA (NCRN, NMBV, 0x00, NMVV, 0x03)
                        }

                        If ((NPVV != 0x00))
                        {
                            RDCA (NCRN, NPBV, 0x00, NPVV, 0x03)
                        }

                        Return (0x00)
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        PCMD = RDCA (NCRN, 0x04, 0x00, 0x00, 0x02)
                        If ((NITV == 0x01))
                        {
                            PRBI = 0x24
                            PRBD = RDCA (NCRN, 0x24, 0x00, 0x00, 0x02)
                        }
                        ElseIf ((NITV == 0x02))
                        {
                            PRBI = 0x10
                            PRBD = RDCA (NCRN, 0x10, 0x00, 0x00, 0x02)
                        }

                        EPD3 ()
                        RPD3 (NCRN)
                        Return (0x00)
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        RPD0 (NCRN)
                        EPD0 ()
                        Local0 = RDCA (NCRN, (NPMV + 0x04), 0x00, 0x00, 0x02)
                        If (((Local0 & 0x08) == 0x00))
                        {
                            CNRS ()
                        }

                        Return (0x00)
                    }

                    Method (_INI, 0, NotSerialized)  // _INI: Initialize
                    {
                        NITV = NIT2 /* External reference */
                        NPMV = NPM2 /* External reference */
                        NPCV = NPC2 /* External reference */
                        NL1V = NL12 /* External reference */
                        ND2V = ND22 /* External reference */
                        ND1V = ND12 /* External reference */
                        NLRV = NLR2 /* External reference */
                        NLDV = NLD2 /* External reference */
                        NEAV = NEA2 /* External reference */
                        NEBV = NEB2 /* External reference */
                        NECV = NEC2 /* External reference */
                        NRAV = NRA2 /* External reference */
                        NMBV = NMB2 /* External reference */
                        NMVV = NMV2 /* External reference */
                        NPBV = NPB2 /* External reference */
                        NPVV = NPV2 /* External reference */
                        NCRN = 0x01
                    }
                }

                Device (NVM3)
                {
                    Name (_ADR, 0x00C3FFFF)  // _ADR: Address
                    Name (PRBI, 0x00)
                    Name (PRBD, 0x00)
                    Name (PCMD, 0x00)
                    Name (NCRN, 0x00)
                    Name (NITV, 0x00)
                    Name (NPMV, 0x00)
                    Name (NPCV, 0x00)
                    Name (NL1V, 0x00)
                    Name (ND2V, 0x00)
                    Name (ND1V, 0x00)
                    Name (NLRV, 0x00)
                    Name (NLDV, 0x00)
                    Name (NEAV, 0x00)
                    Name (NEBV, 0x00)
                    Name (NECV, 0x00)
                    Name (NRAV, 0x00)
                    Name (NMBV, 0x00)
                    Name (NMVV, 0x00)
                    Name (NPBV, 0x00)
                    Name (NPVV, 0x00)
                    Method (EPD0, 0, Serialized)
                    {
                        RDCA (NCRN, (NPMV + 0x04), 0xFFFFFFFC, 0x00, 0x03)
                    }

                    Method (EPD3, 0, Serialized)
                    {
                        RDCA (NCRN, (NPMV + 0x04), 0xFFFFFFFC, 0x03, 0x03)
                    }

                    Method (CNRS, 0, Serialized)
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        RDCA (NCRN, 0x10, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x14, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x18, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x1C, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x20, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x24, 0x00, 0x00, 0x03)
                        RDCA (NCRN, 0x04, 0xFFFFFFF8, PCMD, 0x03)
                        RDCA (NCRN, PRBI, 0x00, PRBD, 0x03)
                        If ((NL1V != 0x00))
                        {
                            RDCA (NCRN, (NL1V + 0x0C), 0xFFFFFF00, ND2V, 0x03)
                            RDCA (NCRN, (NL1V + 0x08), 0x0F, (ND1V & 0xFFFFFFF0), 0x03)
                            RDCA (NCRN, (NL1V + 0x08), 0xFFFFFFFF, ND1V, 0x03)
                        }

                        If ((NLRV != 0x00))
                        {
                            RDCA (NCRN, (NLRV + 0x04), 0xFFFFFFFF, NLDV, 0x03)
                        }

                        RDCA (NCRN, (NPCV + 0x10), 0xFFFFFEBF, (NEAV & 0xFFFC), 0x03)
                        RDCA (NCRN, (NPCV + 0x28), 0xFFFFFBFF, NECV, 0x03)
                        RDCA (NCRN, (NPCV + 0x08), 0xFFFFFF1F, NEBV, 0x03)
                        RDCA (NCRN, 0x68, 0xFFFFFBFF, NRAV, 0x01)
                        If (((NEAV & 0x40) == 0x40))
                        {
                            RDCA (NCRN, 0x50, 0xFFFFFFDF, 0x20, 0x01)
                            While (((RDCA (NCRN, 0x52, 0x00, 0x00, 0x00) & 0x2000) == 0x00))
                            {
                                Stall (0x0A)
                            }
                        }

                        RDCA (NCRN, (NPCV + 0x10), 0xFFFFFFFC, (NEAV & 0x03), 0x03)
                        If ((NMVV != 0x00))
                        {
                            RDCA (NCRN, NMBV, 0x00, NMVV, 0x03)
                        }

                        If ((NPVV != 0x00))
                        {
                            RDCA (NCRN, NPBV, 0x00, NPVV, 0x03)
                        }

                        Return (0x00)
                    }

                    Method (_PS3, 0, Serialized)  // _PS3: Power State 3
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        PCMD = RDCA (NCRN, 0x04, 0x00, 0x00, 0x02)
                        If ((NITV == 0x01))
                        {
                            PRBI = 0x24
                            PRBD = RDCA (NCRN, 0x24, 0x00, 0x00, 0x02)
                        }
                        ElseIf ((NITV == 0x02))
                        {
                            PRBI = 0x10
                            PRBD = RDCA (NCRN, 0x10, 0x00, 0x00, 0x02)
                        }

                        EPD3 ()
                        RPD3 (NCRN)
                        Return (0x00)
                    }

                    Method (_PS0, 0, Serialized)  // _PS0: Power State 0
                    {
                        If ((NITV == 0x00))
                        {
                            Return (0x00)
                        }

                        RPD0 (NCRN)
                        EPD0 ()
                        Local0 = RDCA (NCRN, (NPMV + 0x04), 0x00, 0x00, 0x02)
                        If (((Local0 & 0x08) == 0x00))
                        {
                            CNRS ()
                        }

                        Return (0x00)
                    }

                    Method (_INI, 0, NotSerialized)  // _INI: Initialize
                    {
                        NITV = NIT3 /* External reference */
                        NPMV = NPM3 /* External reference */
                        NPCV = NPC3 /* External reference */
                        NL1V = NL13 /* External reference */
                        ND2V = ND23 /* External reference */
                        ND1V = ND13 /* External reference */
                        NLRV = NLR3 /* External reference */
                        NLDV = NLD3 /* External reference */
                        NEAV = NEA3 /* External reference */
                        NEBV = NEB3 /* External reference */
                        NECV = NEC3 /* External reference */
                        NRAV = NRA3 /* External reference */
                        NMBV = NMB3 /* External reference */
                        NMVV = NMV3 /* External reference */
                        NPBV = NPB3 /* External reference */
                        NPVV = NPV3 /* External reference */
                        NCRN = 0x02
                    }
                }
            }

            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                DIP0 = 0x00
                If ((SizeOf (Arg0) == 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If ((\DPP0 && (M078 & 0x08)))
                    {
                        DIP0 = 0x01
                    }
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    Return (HPTF) /* \_SB_.PCI0.SAT1.PRT0.HPTF */
                }
                Else
                {
                    Return (HDTF) /* \_SB_.PCI0.SAT1.PRT0.HDTF */
                }
            }
        }

        Device (PRT1)
        {
            Name (DIP0, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5               // ......
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3               // ......
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0001FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                DIP0 = 0x00
                If ((SizeOf (Arg0) == 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If ((\DPP1 && (M078 & 0x08)))
                    {
                        DIP0 = 0x01
                    }
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    Return (HPTF) /* \_SB_.PCI0.SAT1.PRT1.HPTF */
                }
                Else
                {
                    Return (HDTF) /* \_SB_.PCI0.SAT1.PRT1.HDTF */
                }
            }
        }

        Device (PRT2)
        {
            Name (DIP0, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5               // ......
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3               // ......
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0002FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                DIP0 = 0x00
                If ((SizeOf (Arg0) == 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If ((\DPP2 && (M078 & 0x08)))
                    {
                        DIP0 = 0x01
                    }
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    Return (HPTF) /* \_SB_.PCI0.SAT1.PRT2.HPTF */
                }
                Else
                {
                    Return (HDTF) /* \_SB_.PCI0.SAT1.PRT2.HDTF */
                }
            }
        }

        Device (PRT3)
        {
            Name (DIP0, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5               // ......
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3               // ......
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Method (_EJ0, 1, NotSerialized)  // _EJx: Eject Device, x=0-9
            {
                \_SB.PCI0.LPC.EC.BEJ0 (Arg0)
            }

            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                If (\_SB.PCI0.LPC.EC.BSTA (0x01))
                {
                    Return (0x0F)
                }
                Else
                {
                    Return (0x00)
                }
            }

            Method (_PLD, 0, Serialized)  // _PLD: Physical Location of Device
            {
                Name (PLDD, Buffer (0x10)
                {
                    /* 0000 */  0x81, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                    /* 0008 */  0x59, 0x11, 0x00, 0x80, 0x03, 0x00, 0x00, 0x00   // Y.......
                })
                Return (PLDD) /* \_SB_.PCI0.SAT1.PRT3._PLD.PLDD */
            }

            Name (_ADR, 0x0003FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                DIP0 = 0x00
                If ((SizeOf (Arg0) == 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    CreateWordField (Arg0, 0x00, M000)
                    If ((M000 & 0xC000))
                    {
                        If (!(M000 & 0x4000))
                        {
                            \IDET = 0x03
                            \_SB.PCI0.LPC.EC.BDEV = 0x03
                        }
                    }
                    Else
                    {
                        \IDET = 0x06
                        \_SB.PCI0.LPC.EC.BDEV = 0x06
                    }

                    If ((\DPP3 && (M078 & 0x08)))
                    {
                        DIP0 = 0x01
                    }
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                0x00 = \_SB.PCI0.LPC.EC.BGID /* External reference */
                Local0
                If ((Local0 == 0x07))
                {
                    Local0 = 0x06
                }

                If ((Local0 == 0x06))
                {
                    If (DIP0)
                    {
                        Return (HPTF) /* \_SB_.PCI0.SAT1.PRT3.HPTF */
                    }
                    Else
                    {
                        Return (HDTF) /* \_SB_.PCI0.SAT1.PRT3.HDTF */
                    }
                }

                If (DIP0)
                {
                    GTFT = \CDFL /* External reference */
                    GTAT = \CDAH /* External reference */
                    Return (DGTF) /* \_SB_.PCI0.SAT1.PRT3.DGTF */
                }

                DTFT = \CDFL /* External reference */
                DTAT = \CDAH /* External reference */
                Return (DDTF) /* \_SB_.PCI0.SAT1.PRT3.DDTF */
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                If ((Arg0 == ToUUID ("bdfaef30-aebb-11de-8a39-0800200c9a66")))
                {
                    Switch (ToInteger (Arg2))
                    {
                        Case (0x00)
                        {
                            Switch (ToInteger (Arg1))
                            {
                                Case (0x01)
                                {
                                    Return (Buffer (0x01)
                                    {
                                         0x0F                                             // .
                                    })
                                }
                                Default
                                {
                                    Return (Buffer (0x01)
                                    {
                                         0x00                                             // .
                                    })
                                }

                            }
                        }
                        Case (0x01)
                        {
                            ODDF = 0x00
                            Return (0x00)
                        }
                        Case (0x02)
                        {
                            \_SB.PCI0.LPC.CSON = 0x01
                            \_SB.PCI0.LPC.EPWG = 0x01
                            Sleep (0xC8)
                            ODDF = 0x01
                            Return (0x01)
                        }
                        Case (0x03)
                        {
                            Sleep (0x0A)
                            \_SB.PCI0.LPC.CSON = 0x00
                            \_SB.PCI0.LPC.EPWG = 0x01
                            Sleep (0x0A)
                            Sleep (0xC8)
                            Return (0x01)
                        }
                        Default
                        {
                            Sleep (0x0A)
                            Return (0x00)
                        }

                    }
                }
                Else
                {
                    Sleep (0x0A)
                    Return (0x00)
                }
            }
        }

        Device (PRT4)
        {
            Name (DIP0, 0x00)
            Name (HDTF, Buffer (0x0E)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5               // ......
            })
            Name (HETF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x09,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (ERTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HPTF, Buffer (0x15)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            Name (HQTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x09, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (HXTF, Buffer (0x1C)
            {
                /* 0000 */  0x02, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xEF, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xF5, 0x5F, 0x00,  // ......_.
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF, 0x10, 0x03, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0xA0, 0xEF                           // ....
            })
            Name (DDTF, Buffer (0x0E)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3               // ......
            })
            CreateByteField (DDTF, 0x01, DTAT)
            CreateByteField (DDTF, 0x08, DTFT)
            Name (DGTF, Buffer (0x15)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0xA0, 0xE3, 0x10, 0x03,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0xA0, 0xEF                     // .....
            })
            CreateByteField (DGTF, 0x01, GTAT)
            CreateByteField (DGTF, 0x08, GTFT)
            Name (_ADR, 0x0004FFFF)  // _ADR: Address
            Method (_SDD, 1, NotSerialized)  // _SDD: Set Device Data
            {
                DIP0 = 0x00
                If ((SizeOf (Arg0) == 0x0200))
                {
                    CreateWordField (Arg0, 0x9C, M078)
                    If ((\DPP4 && (M078 & 0x08)))
                    {
                        DIP0 = 0x01
                    }
                }
            }

            Method (_GTF, 0, NotSerialized)  // _GTF: Get Task File
            {
                If (DIP0)
                {
                    Return (HPTF) /* \_SB_.PCI0.SAT1.PRT4.HPTF */
                }
                Else
                {
                    Return (HDTF) /* \_SB_.PCI0.SAT1.PRT4.HDTF */
                }
            }
        }
    }
}

